]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- remove excess spaces
[packages/rpm.git] / rpm.macros
CommitLineData
a8bf9720
AF
1# PLD rpm macros
2
b5b20129 3# other macros
90c0eaed 4%epoch 0
b5b20129
AM
5%_enable_debug_packages 1
6
5b0f0ac9
MM
7%__id @__ID@
8%__id_u %{__id} -u
9%__chown_Rhf @__CHOWN_RHF@
10%__chgrp_Rhf @__CHGRP_RHF@
11
9fc84bee 12%_fixowner [ `%{__id_u}` = '0' ] && %{__chown_Rhf} root:@ROOT_GROUP@
a8bf9720 13%_fixgroup true
d0bdd45a 14%_fixperms %{__chmod} -Rf @FIXPERMS@
a8bf9720 15%_topdir %(echo $HOME)/rpm
cd33aab7
AM
16#-----------------------------------------------------------------
17# CFLAGS and LDFLAGS used to build
18
d3e82dd7 19%debuginfocflags %{expand:%%define __dic_%{?_enable_debug_packages} 1}%{?__dic_1: -ggdb}%{expand:%%undefine __dic_%{?_enable_debug_packages}}
b5b20129 20
5b0f0ac9 21%debugcflags -O0 -g -Wall
8969de6e
JB
22%rpmcflags %{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}
23%rpmcxxflags %{rpmcflags} -fvisibility-inlines-hidden
c6ac44d9
MM
24%rpmldflags %{nil}
25# %rpmldflags -Wl,--as-needed
cd33aab7 26
a544555d 27# kernel compiler
cabacfeb 28%kgcc gcc
29%kgcc_package gcc
a544555d 30
5f9f9bd7 31# Build system path macros.
32#
429d047e 33%__autoconf autoconf %{?debug:-Wall}
34%__automake automake -a -c -f --foreign
35%__autopoint autopoint --force
36
aad1c8e4 37%__gettextize { \
4da2b97a 38 if ! gettextize --version | grep -q '0\.10\.' ; then \
4cd84746
JB
39 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
40 gettextize --copy --force --no-changelog; \
93bce43f 41 else \
4cd84746
JB
42 gettextize --copy --force --no-changelog --intl; \
43 fi; \
44 if [ ! -f po/Makevars ]; then \
45 cp -f po/Makevars{.template,}; \
46 fi; \
47 else \
48 gettextize --copy --force; \
aad1c8e4 49 fi; \
4cd84746 50}
429d047e 51
52%__glib_gettextize glib-gettextize --copy --force
53%__gnome_doc_common gnome-doc-common --copy
54%__gtkdocize gtkdocize --copy
55%__intltoolize intltoolize --copy --force
56%__libtoolize libtoolize --copy --force
5f9f9bd7 57
bd1cd543 58%dependencytracking %{nil}
cd33aab7 59#-----------------------------------------------------------------
9f0287b5 60%configure2_13 { \
cd33aab7
AM
61 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
62 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
63 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 64 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 65 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
c55f2219 66 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
4eac2e49
AM
67 %{?__cc:CC="%{__cc}" ; export CC ; } \
68 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 69 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 70 --host=%{_target_platform} \
cd33aab7
AM
71 --prefix=%{_prefix} \
72 --exec-prefix=%{_exec_prefix} \
73 --bindir=%{_bindir} \
74 --sbindir=%{_sbindir} \
75 --sysconfdir=%{_sysconfdir} \
76 --datadir=%{_datadir} \
77 --includedir=%{_includedir} \
78 --libdir=%{_libdir} \
79 --libexecdir=%{_libexecdir} \
80 --localstatedir=%{_localstatedir} \
81 --sharedstatedir=%{_sharedstatedir} \
82 --mandir=%{_mandir} \
83 --infodir=%{_infodir} \
72d080a8 84 --x-libraries=/usr/X11R6/%{_lib} \
8b4be1e1 85 %{dependencytracking} \
cd33aab7
AM
86}
87
85f82bec 88#----------------------------------------------------------------
b8cf6778 89%configure {./configure \
85f82bec
AF
90 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
91 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 92 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 93 FFLAGS="${FFLAGS:-%rpmcflags}" \
418d9760 94 CPPFLAGS="${CPPFLAGS:-}" \
4eac2e49
AM
95 %{?__cc:CC="%{__cc}"} \
96 %{?__cxx:CXX="%{__cxx}"} \
85f82bec
AF
97 --build=%{_target_platform} \
98 --prefix=%{_prefix} \
99 --exec-prefix=%{_exec_prefix} \
100 --bindir=%{_bindir} \
101 --sbindir=%{_sbindir} \
102 --sysconfdir=%{_sysconfdir} \
103 --datadir=%{_datadir} \
104 --includedir=%{_includedir} \
105 --libdir=%{_libdir} \
106 --libexecdir=%{_libexecdir} \
107 --localstatedir=%{_localstatedir} \
108 --sharedstatedir=%{_sharedstatedir} \
109 --mandir=%{_mandir} \
110 --infodir=%{_infodir} \
72d080a8 111 --x-libraries=/usr/X11R6/%{_lib} \
8b4be1e1 112 %{dependencytracking} \
85f82bec
AF
113}
114
617b7266 115# ------------------------------------------------------------------------
a0bade1c
AM
116# Overloading of some basic macros
117%prep \
118%%prep\
119LANG=C\
120export LANG\
7febf367 121unset DISPLAY ||:\
7507b4fa 122unset LINGUAS ||:\
a0bade1c
AM
123%{nil}
124
125%build %%build\
126LANG=C\
127export LANG\
7febf367 128unset DISPLAY ||:\
7507b4fa 129unset LINGUAS ||:\
a0bade1c
AM
130%{nil}
131
132%install %{?_enable_debug_packages:%{?buildsubdir:%{debug_package}}}\
133%%install\
134LANG=C\
135export LANG\
7febf367 136unset DISPLAY ||:\
7507b4fa 137unset LINGUAS ||:\
a0bade1c
AM
138%{nil}
139
140# ------------------------------------------------------------------------
617b7266
MM
141# Conditional build stuff.
142
143# Check if symbol is defined.
144# Example usage: %if %{defined with_foo} && %{undefined with_bar} ...
145%defined() %{expand:%%{?%{1}:1}%%{!?%{1}:0}}
146%undefined() %{expand:%%{?%{1}:0}%%{!?%{1}:1}}
147
ed4f631a
MM
148# Shorthand for %{defined with_...}
149%with() %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
150%without() %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
151
617b7266
MM
152# Handle conditional builds. %bcond_with is for case when feature is
153# default off and needs to be activated with --with ... command line
154# switch. %bcond_without is for the dual case.
155#
156# %bcond_with foo defines symbol with_foo if --with foo was specified on
157# command line.
158# %bcond_without foo defines symbol with_foo if --without foo was *not*
159# specified on command line.
160#
161# For example:
162#
163# %bcond_with extra_fonts
164# %bcond_without static
d823b3fb 165# %if %{with extra_fonts}
617b7266
MM
166# ...
167# %endif
d823b3fb 168# %ifdef %{with static}
617b7266
MM
169# ...
170# %endif
171# %{?with_static: ... }
172# %{!?with_static: ... }
173# %{?with_extra_fonts: ... }
174# %{!?with_extra_fonts: ... }
175#
176# The bottom line: never use without_foo, _with_foo nor _without_foo, only
177# with_foo. This way changing default set of bconds for given spec is just
178# a matter of changing single line in it and syntax is more readable.
179%bcond_with() %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
180%bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}
181# ------------------------------------------------------------------------
182
cd33aab7
AM
183# Location of autoconf macros
184%_aclocaldir %(aclocal --print-ac-dir)
185
32720a50
AM
186# Location of omf files
187%_omf_dest_dir %(scrollkeeper-config --omfdir)
188
c5eece2c 189# Location of pkgconfig files
a46897a7 190%_pkgconfigdir /usr/%{_lib}/pkgconfig
c5eece2c 191
c917274d 192# Location of desktop files
193%_desktopdir /usr/share/applications
510f694c 194%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 195
fb08fb4a 196# Location of pixmaps for applnk/desktop files
3a9bb008 197%_pixmapsdir /usr/share/pixmaps
cd33aab7 198
fb08fb4a 199# Location of themable icons for applnk/desktop files
986c3bcd 200%_iconsdir /usr/share/icons
201
c5eece2c
JB
202# Location of fonts directories
203%_fontsdir /usr/share/fonts
204
5cfcbc9e 205# Location of Gtk and associated libraries documentation
e9f33a26 206%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 207
eee08b2d 208# Location of KDE documentation
209%_kdedocdir %{_defaultdocdir}/kde/HTML
210
a7cad6ae 211# unsermake script
212%__unsermake /usr/share/unsermake/unsermake
213
cd33aab7
AM
214# Current date
215%date %(LC_ALL="C" date +"%a %b %d %Y")
216
217# tmp directory
218%tmpdir %(echo "${TMPDIR:-/tmp}")
219
220# Example files, programs, scripts...
221%_examplesdir /usr/src/examples
222
bd63739a 223# The directory holding Linux kernel sources
224%_kernelsrcdir /usr/src/linux
225
cd33aab7 226# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 227%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 228
5b0f0ac9 229# Requires name = version-release
d0bdd45a 230%requires_releq() %(LC_ALL="C" echo '%*' | xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
511ee4c6 231
d0bdd45a
JB
232%releq_kernel_up() %(LC_ALL="C" rpm -qf --qf 'kernel-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
233%releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf 'kernel-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
234%requires_releq_kernel_up() %(LC_ALL="C" rpm -qf --qf 'PreReq: kernel-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
235%requires_releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf 'PreReq: kernel-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
511ee4c6 236
d0bdd45a 237%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
e478b9e7 238
6f3d2288 239%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
8dea1306 240
241# kernel version-release handling
5876e6e3 242%__kernel_ver %([ -f %{_kernelsrcdir}/include/linux/version.h ] && (grep UTS_RELEASE %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
1d969cf0 243%__kernel_rel %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h --queryformat "%{RELEASE}" | grep -v "is not")
d0bdd45a
JB
244%__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h --queryformat "%{VERSION}-%{RELEASE}" | grep -v "is not")
245%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
066309eb 246%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
fd4d8ee0 247
c2c27a5a 248# sgml macros
a0850a21 249%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
250%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
da745cb1 251%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
a0850a21 252%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
253%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
254%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 255%docbook_sgmlcat_fix() { for l in \
256'' \
257' -- default decl --' \
258'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
259' -- hacks for opensp --' \
260'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
261'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
262'' \
263; do echo $l; done >> %1 \
264}
265
cd33aab7
AM
266#-----------------------------------------------------------------
267# find and gzip all files in %{_mandir} and %{infodir}
268#
269# Requires: xargs, find
270#
271#%no_install_post_compress_docs 1
272%__spec_install_post_compress_docs { \
cd33aab7 273%{!?no_install_post_compress_docs: \
89f18684 274 echo "Compress man and info pages."; \
cd33aab7
AM
275 %{?verbose:set -x;} \
276 for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
277 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
278 find "$RPM_BUILD_ROOT$i" -name \*.bz2 -print | xargs -r %{__bzip2} -df; \
279 find "$RPM_BUILD_ROOT$i" -name \*.gz -print | xargs -r %{__gzip} -dnf; \
280 find "$RPM_BUILD_ROOT$i" -type f -print | xargs -r %{__gzip} -9nf; \
281 fi; \
282 done; \
283} }
284
285#-----------------------------------------------------------------
286# Strip executable binaries and shared object files
287#
288# Requires: find, awk, strip, cut, xargs
289#
290#%no_install_post_strip 1
291%__spec_install_post_strip {%{!?debug: \
292%{!?no_install_post_strip: \
f80cefa3
JB
293 %{?verbose:set -x;} \
294 if [ -d "$RPM_BUILD_ROOT" ]; then \
5b0f0ac9 295 echo "Strip executable binaries, archives and shared object files."; \
aaa1486f 296 filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
cd33aab7
AM
297 elfexelist=`echo $filelist | xargs -r file | \
298 awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
299 elfsharedlist=`echo $filelist | xargs -r file | \
300 awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
5b0f0ac9
MM
301 elfarchiveslist=`echo $filelist | xargs -r file | \
302 awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
cd33aab7 303 if [ -n "$elfexelist" ]; then \
aaa1486f 304 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
cd33aab7
AM
305 fi; \
306 if [ -n "$elfsharedlist" ]; then \
aaa1486f 307 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
5b0f0ac9
MM
308 fi; \
309 if [ -n "$elfarchiveslist" ]; then \
aaa1486f 310 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $elfarchiveslist; \
f80cefa3
JB
311 fi; \
312 fi; } \
cd33aab7 313} }
cc545e1a 314#-----------------------------------------------------------------
315# remove all RPATH from executable binaries and shared object files
316#
317# Requires: find, awk, cut, xargs, chrpath, uname
318#
319#%no_install_post_chrpath 1
320%__spec_install_post_chrpath {%{!?debug: \
321%{!?no_install_post_chrpath: \
322 %{?verbose:set -x;} \
f80cefa3 323if [ -d "$RPM_BUILD_ROOT" ]; then \
cc545e1a 324echo "Remove RPATH from executable binaries and shared object files."; \
d274a19d 325find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
3d66db15 326 awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
cc545e1a 327while read file ; do \
328 rpath= ; \
329 chmod u+w "$file"; \
330 for dir in `chrpath -l "$file" | \
331 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
332 case $dir in \
570a0c29 333 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
cc545e1a 334 echo "remove-rpath: $dir in $file"; \
335 ;; \
336 * ) \
337 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
338 else rpath="$rpath:$dir" ; fi ; \
339 ;; \
340 esac ; \
341 done ; \
342 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
343 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
f80cefa3
JB
344done; \
345fi; } \
cc545e1a 346} }
22a54b3e 347#-----------------------------------------------------------------
93b46c00 348# Find and gzip all kernel modules
349#
350# Requires: find
351#
352#%no_install_post_compress_modules 1
353%__spec_install_post_compress_modules { \
93b46c00 354%{!?no_install_post_compress_modules: \
355 %{?verbose:set -x;} \
f80cefa3
JB
356 if [ -d "$RPM_BUILD_ROOT" ]; then \
357echo "Compress kernel modules if any."; \
390bdd1d 358 if test -d $RPM_BUILD_ROOT/lib/modules ; then \
d0bdd45a
JB
359 find $RPM_BUILD_ROOT/lib/modules -name \*o -type f -print | \
360 xargs -r %{__gzip} -9nf; \
fe70546d 361 find $RPM_BUILD_ROOT/lib/modules -name \*o -type l -printf "%p %l\n" | \
92ebeb8d 362 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
390bdd1d 363 fi; \
f80cefa3 364 fi; \
93b46c00 365} }
cd33aab7
AM
366
367%_source_payload w9.gzdio
368%_binary_payload w9.bzdio
369
aad1c8e4 370#-----------------------------------------------------------------
cc6c554c 371# Update GConf2 schemas
aad1c8e4 372#
373# Requires: GConf2
374#
5b8ed3c0 375%gconf_schema_install() \
376 umask 022; \
429d047e 377 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
5b8ed3c0 378 %{nil}
379
380%gconf_schema_uninstall() \
429d047e 381if [ $1 = 0 ]; then \
5b8ed3c0 382 umask 022; \
429d047e 383 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
384fi \
385%{nil}
386
387#-----------------------------------------------------------------
388# Update desktop MIME database
389# requries: desktop-file-utils
390#
391%update_desktop_database_post() \
392 umask 022; \
393 /usr/bin/update-desktop-database; \
394 %{nil}
395
396%update_desktop_database_postun() \
397if [ $1 = 0 ]; then \
398 umask 022; \
399 /usr/bin/update-desktop-database; \
400fi \
401%{nil}
402
403#-----------------------------------------------------------------
404# Update scrollkeeper database
405# requires: scrollkeeper
406#
407%scrollkeeper_update_post() \
429d047e 408 /usr/bin/scrollkeeper-update -q; \
409 %{nil}
410
411%scrollkeeper_update_postun() \
412if [ $1 = 0 ]; then \
429d047e 413 /usr/bin/scrollkeeper-update -q; \
414fi \
415%{nil}
416
417#-----------------------------------------------------------------
418# Run ldconfig after installing/deinstalling libraries
419#
420%ldconfig_post() \
421 /sbin/ldconfig; \
422 %{nil}
423
424%ldconfig_postun() \
429d047e 425 /sbin/ldconfig; \
bbc02b2d 426 %{nil}
aad1c8e4 427
cd33aab7
AM
428#-----------------------------------------------------------------
429# post %install sequence:
430# - autodeps exceptions
431# - compress all man and info pages,
432# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 433# - compress kernel modules if any
cd33aab7
AM
434
435###################################################################
436# Requires/Provides automation
437# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
a4852742 438#
fbbdca08
JB
439%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
440%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
441%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
442%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
443%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a4852742
JB
444#%_noautocompressdoc %{nil}
445#
5b0f0ac9
MM
446%_missing_doc_files_terminate_build 1%{nil}
447%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 448# (X)emacs support
42b7e5ac 449%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
4c7d3ba4
AF
450%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
451%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
41a62699 452
984f6de6
JK
453%__php_provides %{nil}
454%__php_requires %{nil}
455%__perl_provides %{nil}
456%__perl_requires %{nil}
41a62699
AF
457
458# Perl specific macro definitions.
942c693c
AF
459%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
460%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
461%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
462%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
463%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
464%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
41a62699 465
942c693c 466%php_pear_dir %{_datadir}/pear
41a62699
AF
467
468# Python specific macro definitions.
469# python main version
942c693c 470%py_ver %(echo `python -c "import sys; print sys.version[:3]"`)
41a62699
AF
471
472# directories
942c693c 473%py_prefix %(echo `python -c "import sys; print sys.prefix"`)
4ef692e4 474%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 475%py_scriptdir %{py_prefix}/share/python%{py_ver}
942c693c 476%py_incdir /usr/include/python%{py_ver}
a4f0b5e0
JK
477%py_sitedir %{py_libdir}/site-packages
478%py_sitescriptdir %{py_scriptdir}/site-packages
942c693c 479%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
480
481# pure python modules compilation
942c693c 482%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 483
942c693c 484%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
485
486# Software written in Python language require Python with main version
5177c7b1 487%pyrequires_eq() Requires: %1
41a62699 488
ea4b2900
AF
489
490# Hardlink binary identical .pyc and .pyo files
491# (idea by glen <at> pld-linux <dot> org)
492%__spec_install_post_py_hardlink {\
2b8c0cee 493%{!?no_install_post_py_hardlink: \
ea4b2900
AF
494[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
495 b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
496 if cmp -s "$a" "$b"; then \
497 ln -f "$a" "$b"; \
498 fi; \
499done \
500} }
501
16f6f416 502# remove python sources, so that check-files won't complain
ea4b2900
AF
503# (idea by glen <at> pld-linux <dot> org)
504%py_postclean() \
505for d in %{py_sitescriptdir} %{py_sitedir}; do \
506 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -exec rm {} \; ;\
507done \
508%{nil}
509
67ed5b97 510# depmod macro
511%depmod() { \
fe30b3ea 512umask 022; \
67ed5b97 513if [ -e /boot/System.map-%1 ]; then \
514 /sbin/depmod -a -F /boot/System.map-%1 %1; \
515else \
516 if [ -e /boot/System.map ]; then \
517 /sbin/depmod -a -F /boot/System.map %1; \
518 else \
519 /sbin/depmod -a %1; \
520 fi \
521fi; \
522}
523
495892af 524# XMMS specific macros
2f163afd
JB
525%xmms_prefix %(xmms-config --prefix)
526%xmms_exec_prefix %(xmms-config --exec-prefix)
527%xmms_version %(xmms-config --version)
528%xmms_datadir %(xmms-config --data-dir)
529%xmms_plugindir %(xmms-config --plugin-dir)
530%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir)
531%xmms_input_plugindir %(xmms-config --input-plugin-dir)
532%xmms_output_plugindir %(xmms-config --output-plugin-dir)
533%xmms_effect_plugindir %(xmms-config --effect-plugin-dir)
534%xmms_general_plugindir %(xmms-config --general-plugin-dir)
495892af 535
59d9979d 536%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/')
e3618ee9 537
538# user/group checking macros
539#
540# Usage:
541# %userremove myuser
542#
543%userremove /usr/lib/rpm/user_group.sh user del
544%groupremove /usr/lib/rpm/user_group.sh group del
545#
546# Usage:
547# if %usertestrm myuser; then
548# /usr/sbin/userdel -r myuser
549# Note:
550# use these macros only if you need to call userdel/groupdel with
551# a non-standard option or take an extra action; otherwise use the
552# %userremove/%groupremove macros
553#
554%usertestrm /usr/lib/rpm/user_group.sh user testrm
555%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
556# user group membership management macros
557#
558# Usage:
559# %addusertogroup myuser agroup
560#
561%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 562
563# banner support (useful in {pre,post}{,un} and triggers)
564#
565# Usage:
a980efc1 566# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 567# the banner text, the banner text
a980efc1
ER
568# the banner text, and following line
569#EOF
570# You can use any form of here-document, <<'EOF' <<-EOT will do.
571# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
572#
bfd9689c 573# -a - append to the banner
fb033326 574# -e - send to stderr instead of stdout
1257c400 575# -n - no show banner (overrides -t)
576# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
a980efc1 577%banner(aent:) \
f1bbc6ff 578RPM_SCRIPTVERBOSITY=5 \
579[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
580if [ -x /usr/bin/banner.sh ]; then \
a980efc1 581 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 582else \
fb033326 583 CMD="cat%{-e: >&2}" \
f1bbc6ff 584fi \
a980efc1 585$CMD %2%{?3: %3} \
bfd9689c 586%nil
1257c400 587
29c5556c
ER
588# useradd/groupadd macros written by glen@pld-linux.org.
589# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
590#
591# Usage:
592# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
593# [-g initial_group] [-G group[,...]] login
594#
595# -u uid. REQUIRED
596# -g gid/group. REQUIRED
597# -s defaults to /bin/false
598# -d defaults to /usr/share/empty
599# -c No default
600# -r is accepted but ignored (it's always set)
601# rpm specific flags
602# -P package name. defaults to %{name}
603#
29c5556c 604%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
605%{!-u:%{error:useradd: Required argument -u missing}} \
606%{!-g:%{error:useradd: Required argument -g missing}} \
607%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
608if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
609 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
610 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
611 exit 1 \
612 fi \
613else \
614 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
615 /usr/sbin/useradd \\\
616 -u %{-u*} \\\
617 -r \\\
618 -d %{-d*}%{!-d:/usr/share/empty} \\\
619 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 620 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
621 -g %{-g*} \\\
622 %{-M} \\\
623 %{-G:-G %{-G*}} \\\
85e3e9a1 624 %{expand:%{%{#}}} 1>&2 \
29c5556c
ER
625fi;
626
29c5556c
ER
627# Usage:
628# %groupadd [-P package] [-g gid] group
629#
630# -g gid. REQUIRED
631#
632# Sample:
633# %groupadd -P %{name}-base -g %{gid} %{name}
634
635%groupadd(g:P:rfo) \
0044d46f
ER
636%{!-g:%{error:groupadd: Required argument -g missing}} \
637%{!?1:%{error:groupadd: Required parameter group missing}} \
29c5556c
ER
638if [ -n "`/usr/bin/getgid %{1}`" ]; then \
639 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
640 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
641 exit 1 \
642 fi \
643else \
644 echo "Adding group %{1} GID=%{-g*}." \
85e3e9a1 645 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 \
29c5556c 646fi;
This page took 0.153422 seconds and 4 git commands to generate.